package me.hammerle.graphics;

import java.awt.Graphics;
import java.awt.image.BufferedImage;

public class Image extends Line implements Graphic
{
    private int x;
    private int y;
    private BufferedImage image;
    private final GraphicPanel panel;
    
    public Image(GraphicPanel panel, BufferedImage image, int x, int y, int x1, int y1, int x2, int y2)
    {
        super(null, x1, y1, x2, y2);
        this.image = image;
        this.x = x;
        this.y = y;
        this.panel = panel;
    }
    
    public Image(GraphicPanel panel, BufferedImage image, int x, int y)
    {
        this(panel, image, x, y, 0, 0, image.getWidth(), image.getHeight());
    }
    
    public void setX(int x)
    {
        this.x = x;
    }
    
    public void setY(int y)
    {
        this.y = y;
    }

    public int getX()
    {
        return x;
    }

    public int getY()
    {
        return y;
    }
    
    public void setImage(BufferedImage image)
    {
        this.image = image;
    }
    
    @Override
    public void paint(Graphics g) 
    {
        g.drawImage(image.getSubimage(x1, y1, x2 - x1, y2 - y1), x, y, panel);
    }

    @Override
    public boolean hasColor() 
    {
        return false;
    }
}
